//
//	PostcardViewer v1.0 ( Part of PostcardViewer.rwplugin )
//	by Keigo Komino (imacomino) - http://comino.sakura.ne.jp
//	10/07/06 : Add navigation button.
//			   Add parameter variables.
//			   Change declaration name.
//	09/25/06 : 1st edition.
//
//	Licensed under the Creative Commons Attribution 2.5 License
//	http://creativecommons.org/licenses/by/2.5/
//	

var PostcardViewer = Class.create();

//
// PostcardViewer Class
//
PostcardViewer.prototype = {
	initialize: function() {
		var objBody = document.getElementsByTagName("body").item(0);
		var arrayPageSize = getPageSize();

		// Add background element
		var strOverlay = "<div id='postcardviewer-overlay'></div>";
		new Insertion.Top(objBody, strOverlay); 
		var objOverlay = $('postcardviewer-overlay');
		objOverlay.style.display = 'none';
		objOverlay.style.height = arrayPageSize[1] +"px";

		// Add navigation element
		var strNavigationCommand;
		if (typeof postcardViewerTarget!="undefined") {
			strNavigationCommand="<a class='postcardviewer-back' href='javascript:history.back()'></a>";
		} else {
			strNavigationCommand="<a class='postcardviewer-back' href='javascript:myPostcardViewer.hide()'></a>";
		}
		var strNavigation
			= "<div id='postcardviewer-navigation'>"
			+ strNavigationCommand
			+ "</div>";
		new Insertion.After(objOverlay, strNavigation); 
		var objNavigation = $('postcardviewer-navigation');
		objNavigation.style.display = 'none';

		if (typeof postcardViewerTarget!="undefined") {
			this.show(postcardViewerTarget);
		}
	},
	show: function(targetName) {

		// Add postcard element
		var strTarget
			= "<iframe name='postcardviewer-target'"
			+ "allowtransparency='true'"
			+ "src='"+targetName+"'"
			+ "width='100%'"
			+ "height='500px'"
			+ "frameborder='0'"
			+ "scrolling='no'"
			+ "id='postcardviewer-target'>"
			+ "</iframe>";
		new Insertion.After($('postcardviewer-overlay'), strTarget); 
		var objTarget = $('postcardviewer-target');
		objTarget.style.height = arrayPageSize[1] +"px";

		// Show elements
		new Effect.Appear('postcardviewer-overlay',		{ duration: postcardViewerDuration, from: 0.0, to: postcardViewerTransparency });
		new Effect.Appear('postcardviewer-navigation',	{ duration: 1.8, from: 0.0, to: 9.9 });
	},
	hide: function() {
		Element.remove('postcardviewer-target');
		new Effect.Fade('postcardviewer-overlay', { duration: 0.2});
		new Effect.Fade('postcardviewer-navigation', { duration: 0.2});
	}
}

//
// getPageSize()
// Returns array with page width, height and window width, height
// Core code from - quirksmode.org
// Edit for Firefox by pHaez
//
function getPageSize(){
	
	var xScroll, yScroll;
	
	if (window.innerHeight && window.scrollMaxY) {	
		xScroll = document.body.scrollWidth;
		yScroll = window.innerHeight + window.scrollMaxY;
	} else if (document.body.scrollHeight > document.body.offsetHeight){ // all but Explorer Mac
		xScroll = document.body.scrollWidth;
		yScroll = document.body.scrollHeight;
	} else { // Explorer Mac...would also work in Explorer 6 Strict, Mozilla and Safari
		xScroll = document.body.offsetWidth;
		yScroll = document.body.offsetHeight;
	}

	var windowWidth, windowHeight;
	if (self.innerHeight) {	// all except Explorer
		windowWidth = self.innerWidth;
		windowHeight = self.innerHeight;
	} else if (document.documentElement && document.documentElement.clientHeight) { // Explorer 6 Strict Mode
		windowWidth = document.documentElement.clientWidth;
		windowHeight = document.documentElement.clientHeight;
	} else if (document.body) { // other Explorers
		windowWidth = document.body.clientWidth;
		windowHeight = document.body.clientHeight;
	}	

	// for small pages with total height less then height of the viewport
	if(yScroll < windowHeight){
		pageHeight = windowHeight;
	} else { 
		pageHeight = yScroll;
	}

	// for small pages with total width less then width of the viewport
	if(xScroll < windowWidth){	
		pageWidth = windowWidth;
	} else {
		pageWidth = xScroll;
	}

	arrayPageSize = new Array(pageWidth,pageHeight,windowWidth,windowHeight) 
	return arrayPageSize;
}

//
// Initialization handler for postcardViewer
//
function initPostcardViewer() {
	if (typeof myPostcardViewer=="undefined") myPostcardViewer = new PostcardViewer();
}

Event.observe(window, 'load', initPostcardViewer, false);